/***********************************************
* # GPL 2.0 applies.
* # Author: Zhang Yuhong, Ankit Agrawal 
* # Email:	yuhong@eecs.northwestern.edu 
* # Filename: main.cpp
* # Latestd updated 09/21/2011	 
* ************************************************/
#include <mpi.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <InputParse.h>
#include <generic.h>
#include <ErrorHandle.h>
#include <PairwiseStatSig.h>
#include <exception>
#include <cxxabi.h>
#include <iostream>
#include <sstream>
#include <execinfo.h>
#include <ErrorHandle.h>
#include <iostream>
using namespace std;
			
int main(int argc,char* argv[])
{
	
	MPI::Init(argc, argv);
	MPI::COMM_WORLD.Set_errhandler(MPI::ERRORS_THROW_EXCEPTIONS);
	
	int nProcessors = MPI::COMM_WORLD.Get_size(); /* No. of processors */
	int	pRank 		= MPI::COMM_WORLD.Get_rank(); /* rank of processor */
	
	
	CInputParse params;
	StatSig* StatSigMPI_ML = NULL;
	
	//parse parameters
	if(!params.parseParams(argc, argv)){
		return 0;
	}
			
	StatSigMPI_ML = new StatSig(&params);
	
	try{
		if(StatSigMPI_ML){
			StatSigMPI_ML->run();
		}		
	}
	
	catch(MPI::Exception& e) {
		cout << "MPI_ERROR: "<< e.Get_error_code()
			 << " - "<< e.Get_error_string()
			 << endl;
		MPI::COMM_WORLD.Abort (-1) ;
		MPI::Finalize() ;	
	}
	
	catch(ExceptionDerived& e) {
		cout << "ERROR: "<< e.what() << endl;
		MPI::COMM_WORLD.Abort (-1) ;
		MPI::Finalize() ;		
	}
	
	catch(...) {
		cout << "Sorry, some unspecifc errors happened.\n"<< endl;
		MPI::COMM_WORLD.Abort (-1) ;
		MPI::Finalize();	
	}
	
	
	if(pRank == 0){
		StatSigMPI_ML->PrintResult();
	}

	delete StatSigMPI_ML;
	
	MPI::Finalize();
	return 0;	
}
